diff --git a/Makefile b/Makefile
index 1d43e29cca11c06a4ba98e15f1e3fd7b110d2a99..e20018431b3dc257ddd65d3e5f17367354f35b6d 100644
--- a/Makefile
+++ b/Makefile
@@ -55,6 +55,7 @@ test-unit:
 .PHONY: test-style
 test-style:
 	@scripts/validate-go.sh
+	@scripts/Validate-license.sh
 
 .PHONY: protoc
 protoc:
diff --git a/scripts/validate-license.sh b/scripts/validate-license.sh
new file mode 100755
index 0000000000000000000000000000000000000000..fe7ec481bee7a8063885bd470bc5b7696d11e5fb
--- /dev/null
+++ b/scripts/validate-license.sh
@@ -0,0 +1,37 @@
+#!/usr/bin/env bash
+
+# Copyright 2016 The Kubernetes Authors All rights reserved.
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+#     http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+set -euo pipefail
+IFS=$'\n\t'
+
+find_files() {
+  find . -not \( \
+    \( \
+      -wholename './vendor' \
+      -o -wholename './pkg/proto' \
+      -o -wholename '*testdata*' \
+    \) -prune \
+  \) \
+  \( -name '*.go' -o -name '*.sh' -o -name 'Dockerfile' \)
+}
+
+failed=($(find_files | xargs grep -L 'Licensed under the Apache License, Version 2.0 (the "License");'))
+if (( ${#failed[@]} > 0 )); then
+  echo "Some source files are missing license headers."
+  for f in "${failed[@]}"; do
+    echo "  $f"
+  done
+  exit 1
+fi